int pot0;
int vitesse;
int ma=1; // définit le sens de marche
long t0=micros();
long dt; // largeur de l'impulsion PWM à l'état haut qui définit la vitesse du moteur
int vout1; // tension sur la sortie OUT1 du module L298N
int vout2; // tension sur la sortie OUT2 du module L298N
int xm;
int xref;
float k;
long t1=millis();



void setup()
{
Serial.begin(9600);
pinMode(3,OUTPUT); // vers l'entrée IN1 du module L298N
pinMode(5,OUTPUT); // vers l'entrée IN2 du module L298N
pinMode(8,INPUT); // cette entrée définit le sens de marche 
xref=0;
k=0.5;
dt=0;
}

void loop()
{
  
pot0=analogRead(A0); // tension de sorie du point milieu du potentiomètre 
if (pot0<=50) {
digitalWrite(3,LOW);
digitalWrite(5,LOW); 
xref=0; 
}
if (pot0>50) xref=int(pot0/50 + 10); // tension de référence qui définit la vitesse en fonction de la position du potentiomètre


vout1=analogRead(A1);
vout2=analogRead(A2);


dt=dt-int(k*(xm-xref)); // largeur de l'impulsion PWM à l'état haut
if (dt<0) dt=0;
if (dt>5000) dt=5000;

ma=digitalRead(8); // définit le sens de marche ma=1 pour MAV et ma= 0 pour MAR

if (ma==1) {
digitalWrite(5,LOW);
if (micros()<=t0+dt) digitalWrite(3,HIGH);
if (micros()>t0+dt && micros()<=t0+5000) digitalWrite(3,LOW);
if (micros()>t0+5000){
xm=abs(vout1-vout2); //mesure de la tension fcem en sortie entre les broches OUT1 et OUT2 du module L298N
t0=micros();
}
}

if (ma==0) {
digitalWrite(3,LOW);
if (micros()<=t0+dt) digitalWrite(5,HIGH);
if (micros()>t0+dt && micros()<=t0+5000) digitalWrite(5,LOW);
if (micros()>t0+5000){
xm=abs(vout1-vout2);  
t0=micros();
}
}


// affichage des valeurs chaque seconde sur le moniteur lorsque le PC est connecté en USB à l'ARDUINO
if (millis()==t1+1000) {
  Serial.print("dt=");
  Serial.print(dt);
  Serial.print("  xm= ");
  Serial.println(xm);
  t1=millis();
 
}

 
}
